(function () {
    "use strict";

    var qweb = openerp.web.qweb;
    var checkerId = undefined;
    var checker = function() {
        checkerId = setInterval(function () {
            Offline.check();
        }, 1000);
    };

    Offline.options = {
        checkOnLoad: true,
        checks: {
            xhr: {
                url: '/web/static/src/img/favicon.ico?_=' + new Date().getTime()
            }
        }
    };

    Offline.on('up', function () {
        $('.offline-ui').hide({
            effect: 'fade',
            duration: 200
        });
    });

    Offline.on('confirmed-down', function () {
        clearInterval(checkerId);

        $('.offline-ui').show({
            effect: 'fade',
            duration: 200,
            complete: function () {
                $('.offline-ui-content').html(qweb.render('MessageTmpl'));
            }
        });
    });

    Offline.on('reconnect:tick', function (e) {
        var widget = qweb.render('ReconnectTmpl', { remaining: Offline.reconnect.remaining + 1 });
        console.log(widget);
        // $('.offline-reconnect-remaining').replaceWith(widget);
    });

    Offline.on('reconnect:stopped', function () {
        if (Offline.state === 'up') {
            checker();
        }
    });

    checker();
})();
